<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      title="Subjects"
      icon="mdi-octagram-outline"
      show-add-filter
      @trigger="$trigger"
      @refresh="bootstrap"
    >
      <template v-slot:body>
        <v-btn
          color="primary"
          class="mr-2"
          @click="modals.createSubject.status = true"
        >
          <v-icon class="mr-2">
            mdi-plus
          </v-icon>
          Subject
        </v-btn>

        <v-btn
          color="primary"
          @click="modals.createSubSubject.status = true"
        >
          <v-icon class="mr-2">
            mdi-plus
          </v-icon>
          Sub Subject
        </v-btn>
      </template>
    </base-searchbar>

    <v-card>
      <v-data-table
        :headers="subSubjectTableHeader"
        :items="subSubjectsList"
        class="elevation-1"
        :loading="dataStatus.subjectTable.loading"
      >
        <template #item.subject="{ item }">
          <v-btn
            text
            fab
            x-small
            @click="handleClickModifySubject({ item })"
          >
            <v-icon color="primary">
              mdi-pencil
            </v-icon>
          </v-btn>

          <v-btn
            v-if="!item.subject_deleted_at"
            text
            fab
            x-small
            @click="handleClickDeleteSubject({ item })"
          >
            <v-icon color="red">
              mdi-delete
            </v-icon>
          </v-btn>

          <v-btn
            v-if="item.subject_deleted_at"
            text
            fab
            x-small
            @click="handleClickRestoreSubject({ item })"
          >
            <v-icon color="blue">
              mdi-restore
            </v-icon>
          </v-btn>

          {{ item.subject }}
        </template>

        <template #item.actions="{ item }">
          <v-btn
            small
            color="primary"
            class="mr-1"
            @click="handleClickModifySubSubject({ item })"
          >
            Edit
          </v-btn>

          <v-btn
            v-if="!item.sub_deleted_at"
            small
            color="red white--text"
            class="mr-1"
            @click="handleClickDeleteSubSubject({ item })"
          >
            Delete
          </v-btn>

          <v-btn
            v-if="item.sub_deleted_at"
            small
            color="blue"
            @click="handleClickRestoreSubSubject({ item })"
          >
            Restore
          </v-btn>
        </template>
      </v-data-table>
    </v-card>

    <!-- create subject -->
    <base-modal
      v-model="modals.createSubject.status"
      title="create subject"
      @trigger="handleTriggerCreateSubject"
    >
      <template #body>
        <v-text-field
          v-model="modals.createSubject.data.subject"
          label="Subject*"
          outlined
          required
        />
      </template>
    </base-modal>

    <!-- create sub subject -->
    <base-modal
      v-model="modals.createSubSubject.status"
      title="create sub subject"
      @trigger="handleTriggerCreateSubSubject"
    >
      <template #body>
        <v-select
          v-model="modals.createSubSubject.data.subject_id"
          :items="subjectsList"
          item-value="subject_id"
          item-text="subject"
          label="Subject*"
          outlined
        />

        <v-text-field
          v-model="modals.createSubSubject.data.name"
          label="Name*"
          outlined
          required
        />
      </template>
    </base-modal>

    <!-- modify sub subject -->
    <base-modal
      v-model="modals.modifySubSubject.status"
      title="modify sub subject"
      @trigger="handleTriggerModifySubSubject"
    >
      <template #body>
        <v-select
          v-model="modals.modifySubSubject.data.subject_id"
          :items="subjectsList"
          item-value="subject_id"
          item-text="subject"
          label="Subject*"
          outlined
        />

        <v-text-field
          v-model="modals.modifySubSubject.data.name"
          label="Name*"
          outlined
          required
        />
      </template>
    </base-modal>

    <!-- modify subject -->
    <base-modal
      v-model="modals.modifySubject.status"
      title="modify subject"
      @trigger="handleTriggerModifySubject"
    >
      <template #body>
        <v-text-field
          v-model="modals.modifySubject.data.subject"
          label="Name*"
          outlined
          required
        />
      </template>
    </base-modal>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import _get from 'lodash/get'

export default {
  name: 'AdminSubjects',

  data: () => ({
    filterList: ['Subject', 'Sub'],

    subSubjectTableHeader: [
      { text: 'ID', value: 'sub_id' },
      { text: 'Subject', value: 'subject' },
      { text: 'Name', value: 'sub' },
      { text: 'Actions', value: 'actions' }
    ],

    dataStatus: {
      subjectTable: { loading: true }
    },

    modals: {
      createSubject: {
        status: false,
        data: {
          subject: ''
        },
        reset () {
          this.data.subject = ''
        }
      },
      createSubSubject: {
        status: false,
        data: {
          subject_id: '',
          name: ''
        },
        reset () {
          this.data.subject_id = ''
          this.data.name = ''
        }
      },
      modifySubSubject: {
        status: false,
        data: {
          subject_id: '',
          sub_id: '',
          name: ''
        },
        reset () {
          this.data.subject_id = ''
          this.data.sub_id = ''
          this.data.name = ''
        }
      },
      modifySubject: {
        status: false,
        data: {
          subject_id: '',
          subject: ''
        },
        reset () {
          this.data.subject_id = ''
          this.data.subject = ''
        }
      }
    }
  }),

  computed: {
    ...mapState('subjects', {
      subjectsList: 'subjects',
      subSubjectsList: 'subSubjects'
    })
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  methods: {
    ...mapActions('subjects', {
      getSubSubjectsList: 'getSubSubjectsList',
      getSubjectsList: 'getSubjectsList',
      createSubject: 'createSubject',
      createSubSubject: 'createSubSubject',
      modifySubject: 'modifySubject',
      modifySubSubject: 'modifySubSubject',
      deleteSubject: 'deleteSubject',
      deleteSubSubject: 'deleteSubSubject',
      restoreSubject: 'restoreSubject',
      restoreSubSubject: 'restoreSubSubject'
    }),

    bootstrap (payload) {
      const config = {
        loading: 'dataStatus.subjectTable.loading'
      }

      this.statusWrapper(async () => {
        await Promise.all([
          this.getSubSubjectsList({ ...this.$route.query, ...payload }),
          this.getSubjectsList()
        ])
      }, config)
    },

    async handleTriggerCreateSubject () {
      const modal = this.modals.createSubject

      try {
        await this.createSubject(modal.data)

        this.$setAlert({ type: 'success' })

        await this.bootstrap()
        modal.status = false
        modal.reset()
      } catch (error) {
        const message = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text: message })
        throw new Error(error)
      }
    },

    async handleTriggerCreateSubSubject () {
      const modal = this.modals.createSubSubject

      try {
        await this.createSubSubject(modal.data)

        this.$setAlert({ type: 'success' })

        await this.bootstrap()
        modal.status = false
        modal.reset()
      } catch (error) {
        const message = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text: message })
        throw new Error(error)
      }
    },

    handleClickModifySubject ({ item }) {
      const modal = this.modals.modifySubject

      modal.data.subject_id = item.subject_id
      modal.data.subject = item.subject
      modal.status = true
    },

    async handleTriggerModifySubject () {
      const modal = this.modals.modifySubject

      try {
        await this.modifySubject(modal.data)

        this.$setAlert({ type: 'success' })

        await this.bootstrap()
        modal.status = false
        modal.reset()
      } catch (error) {
        const message = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text: message })
        throw new Error(error)
      }
    },

    handleClickModifySubSubject ({ item }) {
      const modal = this.modals.modifySubSubject

      modal.data.subject_id = item.subject_id
      modal.data.sub_id = item.sub_id
      modal.data.name = item.sub
      modal.status = true
    },

    async handleTriggerModifySubSubject () {
      const modal = this.modals.modifySubSubject

      try {
        await this.modifySubSubject(modal.data)

        this.$setAlert({ type: 'success' })

        await this.bootstrap()
        modal.status = false
        modal.reset()
      } catch (error) {
        const message = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text: message })
        throw new Error(error)
      }
    },

    handleClickDeleteSubject ({ item }) {
      const success = async () => {
        try {
          await this.deleteSubject({ subject_id: item.subject_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    },

    handleClickDeleteSubSubject ({ item }) {
      const success = async () => {
        try {
          await this.deleteSubSubject({ sub_id: item.sub_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    },

    handleClickRestoreSubject ({ item }) {
      const success = async () => {
        try {
          await this.restoreSubject({ subject_id: item.subject_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    },

    handleClickRestoreSubSubject ({ item }) {
      const success = async () => {
        try {
          await this.restoreSubSubject({ sub_id: item.sub_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    }

  }
}
</script>
